'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = build;
var suffixToRemove = 'Container';

function addDisplayNameStatement(t, varName) {
    var pos = varName.indexOf(suffixToRemove);
    var displayName = 0 < pos ? varName.substring(0, pos) : varName;

    // <VAR>.displayName = '<VAR>';
    return t.expressionStatement( //
    t.assignmentExpression('=', //
    t.memberExpression(t.identifier(varName), t.identifier('displayName')), // <VAR>.displayName
    t.stringLiteral(displayName)));
}

function build(_ref) {
    var t = _ref.types;

    return {
        visitor: {
            VariableDeclaration: function VariableDeclaration(path, state) {
                if (1 === path.node.declarations.length) {
                    var declarator = path.node.declarations[0];
                    if (t.isIdentifier(declarator.id)) {
                        var varName = declarator.id.name;
                        var initExpression = declarator.init;
                        var methodName = state.opts.methodName;

                        if (t.isCallExpression(initExpression)) {
                            var callee = initExpression.callee;
                            if (t.isMemberExpression(initExpression.callee)) {
                                callee = callee.object.callee;
                            }
                            if (callee && methodName === callee.name) {
                                var statementPath = t.isExportNamedDeclaration(path.parentPath) ? path.parentPath : path;
                                statementPath.insertAfter(addDisplayNameStatement(t, varName));
                            }
                        }
                    }
                }
            }
        }
    };
}